/*
 * access.c
 *
 * Copyright (C) 1993 Alain Knaff
 */
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <string.h>
#include "zlibc.h"
#include <syscall.h>

#ifdef NEED_PROTOTYPES
int access(__const char *filename,int mode)
#else
int access(filename,mode)
char *filename; int mode;
#endif
{
  int ret;

  ret= syscall(SYS_access, filename, mode);
  if ( ret >= 0 )
    return 0;
  {
    char newname[MAXPATHLEN + MAXEXTLEN + 1];

    zlib_initialise();
    if ( zlib_mode & CM_DISAB )
      return ret;

    strncpy(newname,filename,1024);
    strcat(newname,zlib_ext);

    return syscall(SYS_access,newname, mode);
  }
}
